picard.fingerprint

## Class HaplotypeProbabilitiesFromGenotypeLikelihoods

- java.lang.Object
- - picard.fingerprint.HaplotypeProbabilities
  - - picard.fingerprint.HaplotypeProbabilitiesFromGenotypeLikelihoods

-     public class HaplotypeProbabilitiesFromGenotypeLikelihoods
      extends HaplotypeProbabilities

  Represents the likelihood of the HaplotypeBlock given the GenotypeLikelihoods (GL field from a VCF, which is actually a log10-likelihood) for each of the SNPs in that block. By convention the alleles stored for each SNP are in phase.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class picard.fingerprint.HaplotypeProbabilities

      `HaplotypeProbabilities.Genotype`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HaplotypeProbabilitiesFromGenotypeLikelihoods(HaplotypeBlock haplotypeBlock)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addToLogLikelihoods(Snp snp, List<htsjdk.variant.variantcontext.Allele> alleles, double[] logGenotypeLikelihoods)` Adds a base observation with the observed quality to the evidence for this haplotype based on the fact that the SNP is part of the haplotype.
    `double[]` | `getLikelihoods()` Converts the loglikelihoods into linear-space.
    `double` | `getLodMostProbableGenotype()` Overridden to calculate the LOD from the loglikelihoods instead of the probabilities because it will allow for more accurate calculation before overflowing.
    `double[]` | `getLogLikelihoods()` Since this class uses loglikelihoods natively, we override and return the native variable
    `double[]` | `getPosteriorProbabilities()` Returns the posterior probability of the haplotypes given the evidence (uses the internal prior)
    `Snp` | `getRepresentativeSnp()` Simple returns the SNP from the haplotype that has the lowest genome coordinate.
    `boolean` | `hasEvidence()` Returns true if evidence has been added, false if the probabilities are just the priors.
    `void` | `merge(HaplotypeProbabilities other)` Merges information from another haplotype probabilities object for the same haplotype into this object.
    `void` | `setLogLikelihoods(double[] ll)`

    - ### Methods inherited from class picard.fingerprint.HaplotypeProbabilities

      `getHaplotype, getMostLikelyGenotype, getMostLikelyHaplotype, getObsAllele1, getObsAllele2, getPriorProbablities, getTotalObs, scaledEvidenceProbabilityUsingGenotypeFrequencies, shiftedLogEvidenceProbability, shiftedLogEvidenceProbabilityGivenOtherEvidence, shiftedLogEvidenceProbabilityUsingGenotypeFrequencies`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HaplotypeProbabilitiesFromGenotypeLikelihoods

          public HaplotypeProbabilitiesFromGenotypeLikelihoods(HaplotypeBlock haplotypeBlock)

  - ### Method Detail

    - #### addToLogLikelihoods

          public void addToLogLikelihoods(Snp snp,
                                          List<htsjdk.variant.variantcontext.Allele> alleles,
                                          double[] logGenotypeLikelihoods)

      Adds a base observation with the observed quality to the evidence for this haplotype based on the fact that the SNP is part of the haplotype.
      Parameters:
        `snp` - The snp in the haplotypeblock to which the likelihoods belong
        `alleles` - the (ordered) alleles to which the biallelic genotype likelihoods correspond. So that if the alleles are [A,B], the
        `logGenotypeLikelihoods` - correspond to the logLikelihoods of [AA, AB, BB]. Log is assumed to be in base 10.

    - #### getRepresentativeSnp

          public Snp getRepresentativeSnp()

      Simple returns the SNP from the haplotype that has the lowest genome coordinate.
      Specified by:
        `getRepresentativeSnp` in class `HaplotypeProbabilities`

    - #### hasEvidence

          public boolean hasEvidence()

      Description copied from class: `HaplotypeProbabilities`
      Returns true if evidence has been added, false if the probabilities are just the priors.
      Overrides:
        `hasEvidence` in class `HaplotypeProbabilities`

    - #### merge

          public void merge(HaplotypeProbabilities other)

      Merges information from another haplotype probabilities object for the same haplotype into this object. Useful for when probabilities need to be merged to levels higher than the read group, e.g. the sample or individual.
      Specified by:
        `merge` in class `HaplotypeProbabilities`
      Parameters:
        `other` - Another haplotype probabilities object to merge in (must of the the same class and for the same HaplotypeBlock)

    - #### getPosteriorProbabilities

          public double[] getPosteriorProbabilities()

      Returns the posterior probability of the haplotypes given the evidence (uses the internal prior)
      Overrides:
        `getPosteriorProbabilities` in class `HaplotypeProbabilities`

    - #### getLikelihoods

          public double[] getLikelihoods()

      Converts the loglikelihoods into linear-space.
      Specified by:
        `getLikelihoods` in class `HaplotypeProbabilities`

    - #### getLogLikelihoods

          public double[] getLogLikelihoods()

      Since this class uses loglikelihoods natively, we override and return the native variable
      Overrides:
        `getLogLikelihoods` in class `HaplotypeProbabilities`

    - #### setLogLikelihoods

          public void setLogLikelihoods(double[] ll)

    - #### getLodMostProbableGenotype

          public double getLodMostProbableGenotype()

      Overridden to calculate the LOD from the loglikelihoods instead of the probabilities because it will allow for more accurate calculation before overflowing.
      Overrides:
        `getLodMostProbableGenotype` in class `HaplotypeProbabilities`